import requests
import discord


def download_image(url, path=None):

    request = requests.get(url)
    suffix_list = [
        "jpeg",
        "jpg",
        "png",
        "tif",
        "svg",
    ]
    extension = request.headers["content-type"].split("/")[1]

    if not path:
        path = "/tmp/image.{}".format(extension)

    if extension in suffix_list:
        open(path, "wb").write(requests.get(url).content)
        return path
    return "Invalid image format"


def generate_embed(
    embed_url=None,
    embed_title=None,
    embed_description=None,
    embed_color=None,
    author_name=None,
    author_image=None,
):
    """
    generate_embed(embed_url=None, embed_title=None, embed_description=None, embed_color=None)

    Generates a discord embed object based on the URL passed in
    Optionally, you can set the title and description text for the embed object.
    """

    if not embed_description and embed_url:
        embed_description = "[Direct Link]({})".format(embed_url)

    if not embed_color:
        embed_color = discord.Color.gold()

    embed = discord.Embed(
        title=embed_title, description=embed_description, color=embed_color, type="rich"
    )
    if embed_url:
        embed.set_image(url=embed_url)

    if author_image or author_name:
        embed.set_author(name=author_name, icon_url=author_image)

    return embed


def gen_username():
    url = "https://generatorfun.com/code/model/generatorcontent.php?recordtable=generator&recordkey=960&gen=Y&itemnumber=1&randomoption=undefined&genimage=Yes&geneditor=No&nsfw=undefined&keyword=undefined&searchfilter=&searchfilterexclude=&tone=Normal&prefix=None&randomai=undefined"

    response = requests.get(url).text
    # This is ugly as fuck but i didnt want to break out beautiful soup
    return response.split(
        "div id='gencont'><hr size=0 style='border-color:grey;opacity:.5;'><div><p>"
    )[1].split(" </p>")[0]
